##################  Script D'installation TeamViewer sur raspberry ##################
#                                                                                   #
#  __ Author            __ : SMOUTS Frederic                                        #
#  __ Copyright         __ : Copyright 2021, TOULINFO                               #
#  __ Credits           __ : SMOUTS Frederic                                        #
#                                                                                   #
#  __ Creation Date     __ : 06/09/2021                                             #
#  __ Last Modification __ : 13/09/2021                                             #
#  __ License           __ : GPL                                                    #
#  __ Version           __ : 2.0                                                    #
#  __ Email             __ : Contact@toulinfo.com                                   #
#  __ Status            __ : Production                                             #
#                                                                                   #
#####################################################################################



#!/usr/bin/env python3

#Importaiton des librairies necessaires
import os
import pathlib
import subprocess
import stat
import smtplib
import ssl
from tkinter import messagebox

######################################################################
###############  Bloc d'installation TeamViewer ######################
######################################################################

#Ancien Bloc d'installation
"""
#Positionnnement dans le repertoire ou se trouve les script BASH
CURRENT_DIR = pathlib.Path(__file__).parent.resolve()  # parent path of the current file
EXECUTABLE = f"{CURRENT_DIR}/team.sh"

#Modification des droits pour rendre le script executable
st = os.stat(EXECUTABLE)
os.chmod(EXECUTABLE, st.st_mode | stat.S_IEXEC)

#Appel du scritp
subprocess.run(["bash", EXECUTABLE])

#Temporisation post-install
#from time import sleep
#sleep(300)
"""

#Nouvelle Methode sans fichier externe

subprocess.run("sudo  apt update --allow-releaseinfo-change", shell=True) #MAJ des sources
subprocess.run("wget https://download.teamviewer.com/download/linux/teamviewer-host_armhf.deb", shell=True) #Download du programme
subprocess.run("ls | grep teamviewer-host_armhf.deb", shell=True)
subprocess.run("sudo apt install -y ./teamviewer-host_armhf.deb", shell=True) #Installation du programme
subprocess.run("sudo apt -fy install", shell=True) #installation des dépendances
subprocess.run("sudo teamviewer passwd Lm_2021!@;", shell=True) #MAJ du MDP

#Temporisation post-install
from time import sleep
sleep(120)



##########################################################
############### Récupération de L' ID ####################
##########################################################

#Ancien Bloc fonction de recherche de l'id dans un fichier
"""
#on se postionne dans le repertoire ou se trouve les script
CURRENT_DIR = pathlib.Path(__file__).parent.resolve()  # parent path of the current file
script_footfall = f"{CURRENT_DIR}/openstan.py"

#fonction de recherche du mail du magasin
def recherche_mail (script_footfall,variable_mail):
    mail_magasin =[] 
    with open(script_footfall) as f:
        lines = reversed(f.readlines()) # start from end of file
        for line in lines:
            if teamid in line: # si on trouve la chaine prédefini 
                mail_magasin.append((line.rsplit("=",1)[-1])) # on recupere juste l'email
    return mail_magasin

variable_mail="mysStanEmail ="
magasin=recherche_mail(script_footfall,variable_mail) #Appel de la focntion
"""
     
#Fonction de recupération de l'ID
out = subprocess.Popen("sudo grep -o 'ClientID = [0-9]*' /etc/teamviewer/global.conf",shell=True, stdout=subprocess.PIPE).stdout
clientid = out.read()

#Fonction de récupération du code magasin
mac = subprocess.Popen("ifconfig eth0 | grep -o -E '([[:xdigit:]]{1,2}:){5}[[:xdigit:]]{1,2}'",shell=True, stdout=subprocess.PIPE).stdout
clientmac = mac.read()

#Ancienne fonction d'affichage dans un Pop-up
#messagebox.showinfo("TeamViewer", out.read())



#########################################################################
################# Bloc Envoie des ID TeamViewer par mail ################
#########################################################################

# on rentre les renseignements pris sur le site du fournisseur
smtp_address = 'smtp.gmail.com'
smtp_port = 465

# on rentre les informations sur notre adresse e-mail
email_address = 'test.mail.raspy'
email_password = 'F0otf@ll'

# on rentre les informations sur le destinataire
email_receiver = 'toulinfo@gmail.com'

#Formation du message avec les info recupere

message = """From: {}
To: {}
Subject: Team Viewer ID for {}

{}.
""".format(email_address, email_receiver,clientmac,clientid)


# on crée la connexion
context = ssl.create_default_context()
with smtplib.SMTP_SSL(smtp_address, smtp_port, context=context) as server:
    server.set_debuglevel(1)
  # connexion au compte
    server.login(email_address, email_password)
  # envoi du mail
    server.sendmail(email_address, email_receiver, message)



########################################################################
##################### Reboot du systeme pour finaliser #################
########################################################################

#Temporisation post-install
from time import sleep
sleep(300)

#Commande reboot    
os.system("sudo reboot")